<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
	<title></title>
	<meta http-equiv="content-type" content="text/html; charset=UTF-8" />
	<link href="stylesheet.css" rel="stylesheet" type="text/css" />
</head>
<body>
<?php

class a_file{

	public $file_name;
	public $directory;
	public $sm_data;
	public $file_type;

	function __construct($directory, $entry) {
		$this->file_name = $entry;
		$this->directory = $directory;

		$substrings = explode(".", $this->file_name);	
		$this->file_type = strtolower($substrings[sizeof($substrings) - 1]);

		//echo "filename received: ".$this->file_name."<br />";
	}
	function get_file_name(){
		//echo "getting file name (".$this->file_name.")<br />";
		return $this->file_name;
	}
	function get_file_type(){
		return $this->file_type;
	}
	function get_file_size(){
		
		return filesize($this->directory."/".$this->file_name);
	}
	function is_zip(){
		if ($this->get_file_type() == "zip" || $this->get_file_type() == "rar" 
			|| $this->get_file_type() == "ZIP" || $this->get_file_type() == "RAR"){
			 return true;
		}
		else {
			return false;
		}
	}
	function is_picture(){
		
		if ($this->get_file_type() == "jpg" || $this->get_file_type() == "jpeg" 
			|| $this->get_file_type() == "gif" || $this->get_file_type() == "png"){
			 return true;
		}
		else {
			return false;
		}
	}	
	function is_sm(){
		if ($this->get_file_type() == "sm"){
			//parse_sm("test/".$this->file_name);
			$this->sm_data = new sm_data($this->directory."/".$this->file_name);
			 return true;
		}
		else {
			//echo "not an sm file<br />";
			return false;
		}
	}	

}

class sm_data{

	public $song_title;
	public $file_name;

	public $song_artist;
	public $song_subtitle;
	public $song_titletranslit;
	public $song_artisttranslit;
	public $song_subtitletranslit;
	public $bpm_min;
	public $bpm_max;

	public $single_beginner;
	public $single_easy;
	public $single_medium;
	public $single_hard;
	public $single_challenge;
	public $double_beginner;
	public $double_easy;
	public $double_medium;
	public $double_hard;
	public $double_challenge;

	private $displaybpm;
	private $displaybpm2;
	private $bpm_data;

	function __construct($entry){
		$this->file_name = $entry;
		$sections = file_get_contents($entry);
		$lines = explode(";", $sections);
		foreach ($lines as $line_num => $untrimmed_line) {
			$line = trim($untrimmed_line);
	    		
			$substrings = explode(":", $line);
				
			foreach ($substrings as &$contents){
				$contents = trim($contents); 		
				//echo htmlspecialchars($contents)."<br />";
			}
			
			if ($substrings[0] == "#TITLE" || $substrings[0] == "﻿#TITLE") $this->song_title = $substrings[1];
			if ($substrings[0] == "#TITLETRANSLIT") $this->song_titletranslit = $substrings[1];
			
			if ($substrings[0] == "#SUBTITLE") $this->song_subtitle = $substrings[1];
			if ($substrings[0] == "#SUBTITLETRANSLIT") $this->song_subtitletranslit = $substrings[1];

			if ($substrings[0] == "#ARTIST") $this->song_artist = $substrings[1];
			if ($substrings[0] == "#ARTISTTRANSLIT") $this->song_artisttranslit = $substrings[1];

			if ($substrings[0] == "#DISPLAYBPM"){ 
				$this->displaybpm = $substrings[1];	
				 $this->displaybpm2 = $substrings[2];	
			}
			if ($substrings[0] == "#BPMS") $this->get_bpm_range($substrings[1]);

			

			if (strstr($substrings[0], "#NOTES")){
				if ($substrings[1] == "dance-single"){
					if ($substrings[3] == "Beginner" || $substrings[3] == "beginner") $this->single_beginner = $substrings[4];			
					if ($substrings[3] == "Easy" || $substrings[3] == "easy") $this->single_easy = $substrings[4];			
					if ($substrings[3] == "Medium" || $substrings[3] == "medium") $this->single_medium = $substrings[4];			
					if ($substrings[3] == "Hard" || $substrings[3] == "hard") $this->single_hard = $substrings[4];			
					if ($substrings[3] == "Challenge" || $substrings[3] == "challenge") $this->single_challenge = $substrings[4];			

				}	
				else if  ($substrings[1] == "dance-double"){
					if ($substrings[3] == "Beginner" || $substrings[3] == "beginner") $this->double_beginner = $substrings[4];			
					if ($substrings[3] == "Easy" || $substrings[3] == "easy") $this->double_easy = $substrings[4];			
					if ($substrings[3] == "Medium" || $substrings[3] == "medium") $this->double_medium = $substrings[4];			
					if ($substrings[3] == "Hard" || $substrings[3] == "hard") $this->double_hard = $substrings[4];			
					if ($substrings[3] == "Challenge" || $substrings[3] == "challenge") $this->double_challenge = $substrings[4];			

				}

			}

		}
	
	}

	function get_bpm_range($bpm_data){
		//echo $bpm_data."<br />";
		
		if (!is_null($this->displaybpm)){

			$this->bpm_min = round($this->displaybpm, 0);	
			if (!is_null($this->displaybpm2)){
				$this->bpm_max = round($this->displaybpm2, 0);
			}	
			else $this->bpm_max = round($this->displaybpm, 0);	

		}
		else
		{
			$bpm_data1 = explode(",", $bpm_data);
			foreach ($bpm_data1 as $bpm_data2){
				//echo $bpm_data2."<br />";
				$bpms = explode("=", $bpm_data2);
				foreach ($bpms as $testtest){ 
					$bpms2[] = round($bpms[1], 0);
					$this->bpm_min = min($bpms2);
					$this->bpm_max = max($bpms2);
					
				}
			}
		}
		//echo $this->bpm_min."-".$this->bpm_max."<br />";
	}
	function show_bpm_range(){
		echo $this->bpm_min;
		if ($this->bpm_min != $this->bpm_max) echo "-".$this->bpm_max;

	}

	function display_song_info(){
		echo $this->song_title."<br />";
		echo $this->song_artist."<br />";
		echo $this->song_subtitle."<br />";
		echo $this->song_titletranslit."<br />";
		echo $this->song_artisttranslit."<br />";
		$this->show_bpm_range();
		echo "<br />";
		echo $this->song_subtitletranslit."<br />";
		echo "single ";
		echo $this->single_beginner."|";
		echo $this->single_easy."|";
		echo $this->single_medium."|";
		echo $this->single_hard."|";
		echo $this->single_challenge."<br />";
		echo "double ";
		echo $this->double_beginner."|";
		echo $this->double_easy."|";
		echo $this->double_medium."|";
		echo $this->double_hard."|";
		echo $this->double_challenge."<br />";
		echo "<br />";
	}

	function stepchart_gen_link($file, $style, $difficulty, $foot_rating){
		echo "<a href=\"smsend.php?sm=".htmlentities($file)."&amp;style=".$style."&amp;difficulty=".$difficulty."\" target=\"blank\">";
		echo $foot_rating;
		echo "</a>";

		//echo "<form name=\"smform".$file $style $difficulty."\" action=\"smsend.php\" method=\"post\">";
		//echo "<input name=\"sm\" value=\"".$file."\" type=\"hidden\" />";
		//echo "<input type=\"text\" name="user" />
		//echo "</form>";
		
	}

	function display_song_info_table(){
		echo "<td>";
		echo $this->song_title." ".$this->song_subtitle;
		if (!is_null($this->song_titletranslit)) 
			echo "<br /><i>".$this->song_titletranslit." ".$this->song_subtitletranslit."</i>";
		echo "</td>\n";
		echo "<td>";
		echo $this->song_artist;
		if (!is_null($this->song_artisttranslit)) 
			echo "<br /><i>".$this->song_artisttranslit."</i>";

		echo "</td>\n";
		echo "<td>";
		$this->show_bpm_range();
		echo "</td>\n";
		echo "<td class=\"beginner\">";
		$this->stepchart_gen_link($this->file_name, "dance-single", "beginner", $this->single_beginner);
		echo "</td>\n";
		echo "<td class=\"easy\">";
		$this->stepchart_gen_link($this->file_name, "dance-single", "easy", $this->single_easy);

		echo "</td>\n";
		echo "<td class=\"medium\">";
		$this->stepchart_gen_link($this->file_name, "dance-single", "medium", $this->single_medium);
		echo "</td>\n";
		echo "<td class=\"hard\">";
		$this->stepchart_gen_link($this->file_name, "dance-single", "hard", $this->single_hard);
		echo "</td>\n";
		echo "<td class=\"challenge\">";
		$this->stepchart_gen_link($this->file_name, "dance-single", "challenge", $this->single_challenge);
		echo "</td>\n";
		echo "<td class=\"beginner\">";
		$this->stepchart_gen_link($this->file_name, "dance-double", "beginner", $this->double_beginner);
		echo "</td>\n";
		echo "<td class=\"easy\">";
		$this->stepchart_gen_link($this->file_name, "dance-double", "easy", $this->double_easy);

		echo "</td>\n";
		echo "<td class=\"medium\">";
		$this->stepchart_gen_link($this->file_name, "dance-double", "medium", $this->double_medium);
		echo "</td>\n";
		echo "<td class=\"hard\">";
		$this->stepchart_gen_link($this->file_name, "dance-double", "hard", $this->double_hard);
		echo "</td>\n";
		echo "<td class=\"challenge\">";
		$this->stepchart_gen_link($this->file_name, "dance-double", "challenge", $this->double_challenge);
		echo "</td>\n";
	}
}

function parse_sm($sm_file){
	$sections = file_get_contents($sm_file);
	$lines = explode(";", $sections);
	foreach ($lines as $line_num => $untrimmed_line) {
		$line = trim($untrimmed_line);
    		
		$substrings = explode(":", $line);
			
		foreach ($substrings as &$contents){
			$contents = trim($contents); 		
			//echo htmlspecialchars($contents)."<br />";
		}
		
		if ($substrings[0] == "#TITLE") echo "Song: ".$substrings[1]."<br />";

		if ($substrings[0] == "#SUBTITLE") echo "Subtitle: ".$substrings[1]."<br />";
		if ($substrings[0] == "#ARTIST") echo "Artist: ".$substrings[1]."<br />";

		if (strstr($substrings[0], "#NOTES")){
			if ($substrings[1] == "dance-single") echo "Single ";
			else if  ($substrings[1] == "dance-double") echo "Double ";

			if ($substrings[3] == "Beginner") echo "Beginner ";
			else if ($substrings[3] == "Easy") echo "Light ";
			else if ($substrings[3] == "Medium") echo "Standard ";
			else if ($substrings[3] == "Hard") echo "Heavy ";
			else if ($substrings[3] == "Challenge") echo "Challenge ";
			echo $substrings[4]."<br />";




		}

		
	}

}

function title_cmp($a, $b){
	echo $a_title;
	if ($a->song_titletranslit != "") $a_title = strtolower($a->song_titletranslit);
	else $a_title = strtolower($a->song_title);

	if ($b->song_titletranslit != "") $b_title = strtolower($b->song_titletranslit);
	else $b_title = strtolower($b->song_title);

	return strcmp($a_title, $b_title);

}


$d = dir("./");

while (false !== ($entry = $d->read())) {
	$file_array[] = new a_file($d, $entry);
	$num_files += 1;
}
$d->close();

//$dir_array[] = "./";
foreach($file_array as $i => $moo){
	if (is_dir($moo->file_name)){
		if ($moo->file_name != "." && $moo->file_name != "..") $dir_array[] = $moo->file_name;
	}

}

echo "<p class=\"bannerimage\">";
foreach($file_array as $j => $moo){
	if ($moo->is_picture()){
		echo "<img src=\"".$moo->file_name."\" />";
	}
}
echo "</p>";	

foreach($dir_array as $i => $dir){	

	echo "<div class=\"header\"><h1>".$dir."</h1></div>";

	$d2 = dir("./".$dir);
	while (false !== ($entry = $d2->read())) {
		$file_array1[$i][] = new a_file($dir, $entry);
		$num_files += 1;
	}
	$d2->close();


	foreach($file_array1[$i] as $j => $moo){

		if ($moo->is_sm()){
			$sm_array[$i][] = $moo->sm_data;
		}
	}



	usort($sm_array[$i], "title_cmp");

	$num_single_beginner = 0;
	$num_single_easy= 0;
	$num_single_medium = 0;
	$num_single_hard = 0;
	$num_single_challenge = 0;
	$num_double_beginner = 0;
	$num_double_easy= 0;
	$num_double_medium = 0;
	$num_double_hard = 0;
	$num_double_challenge = 0;

	foreach ($sm_array[$i] as $bleh){
		if (!is_null($bleh->single_beginner)) $num_single_beginner += 1;
		if (!is_null($bleh->single_easy)) $num_single_easy+= 1;
		if (!is_null($bleh->single_medium)) $num_single_medium += 1;
		if (!is_null($bleh->single_hard)) $num_single_hard += 1;
		if (!is_null($bleh->single_challenge)) $num_single_challenge+= 1;
		if (!is_null($bleh->double_beginner)) $num_double_beginner += 1;
		if (!is_null($bleh->double_easy)) $num_double_easy+= 1;
		if (!is_null($bleh->double_medium)) $num_double_medium += 1;
		if (!is_null($bleh->double_hard)) $num_double_hard += 1;
		if (!is_null($bleh->double_challenge)) $num_double_challenge += 1;
	
	
	}

	echo "<p class=\"downloadlink\">";
	foreach($file_array1[$i] as $j => $moo){
		if ($moo->is_zip()){
			echo "<a href=\"".$moo->get_file_name()."\">Download ".$moo->get_file_name()." (".$moo->get_file_size()." bytes)</a>";
		}
	}
	echo "</p>";
	
	echo "<p class=\"stats\">";
	echo "There are " . sizeof($sm_array[$i]) . " songs in this collection<br />\n";
	echo "</p>";
	
	echo "<p class=\"stats\">";
	if ($num_single_beginner != 0) echo $num_single_beginner." Single Novice<br />\n";
	if ($num_single_easy!= 0) echo $num_single_easy." Single Easy<br />\n";
	if ($num_single_medium!= 0) echo $num_single_medium." Single Medium<br />\n";
	if ($num_single_hard!= 0) echo $num_single_hard." Single Hard<br />\n";
	if ($num_single_challenge!= 0) echo $num_single_challenge." Single Expert<br />\n";
	if ($num_double_beginner != 0) echo $num_double_beginner." Double Novice<br />\n";
	if ($num_double_easy!= 0) echo $num_double_easy." Double Easy<br />\n";
	if ($num_double_medium!= 0) echo $num_double_medium." Double Medium<br />\n";
	if ($num_double_hard!= 0) echo $num_double_hard." Double Hard<br />\n";
	if ($num_double_challenge!= 0) echo $num_double_challenge." Double Expert<br />\n";
	echo "</p>";

	echo "<table>";
	echo "<tr>";
	echo "<th rowspan=\"2\">Song</th>\n";
	echo "<th rowspan=\"2\">Artist</th>\n";
	echo "<th rowspan=\"2\">BPM</th>\n";
	echo "<th colspan=\"5\">Single</th>\n";
	echo "<th colspan=\"5\">Double</th>\n";

	echo "</tr>\n\n";
	echo "<tr>";
	echo "<th>Nov</th>\n";
	echo "<th>Esy</th>\n";
	echo "<th>Med</th>\n";
	echo "<th>Hrd</th>\n";
	echo "<th>Exp</th>\n";
	echo "<th>Nov</th>\n";
	echo "<th>Esy</th>\n";
	echo "<th>Med</th>\n";
	echo "<th>Hrd</th>\n";
	echo "<th>Exp</th>\n";
	echo "</tr>\n\n";

	foreach ($sm_array[$i] as $bleh){
		echo "<tr>";
			
		$bleh->display_song_info_table();
		echo "</tr>\n\n";
	}
	echo "</table>";

}


?>
</body>
</html>
